#
#  Makefile Setting for Cray XE6 PrvEnv-gnu
#

# for parallel programs
PCC		= cc
PCOPTFLAG       = -O3 -std=c99 -msse2 -mfpmath=sse -fprefetch-loop-arrays -ffast-math -funroll-all-loops -fstrict-aliasing -fomit-frame-pointer -ftree-vectorize -fivopts -ftracer -fschedule-insns2 -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
PCOMPFLAG	= -fopenmp 
PLD		= cc
PLIBFLAG	= 
PARCH		= -gnu

# for serial programs
CC		= gcc
COPTFLAG	= $(PCOPTFLAG)
LD		= gcc
LDFLAG		= 
LIBFLAG		= 
ARCH		= $(PARCH)

MARBLEHOME	= ../..
BINDIR		= $(MARBLEHOME)/bin
DATDIR		= $(MARBLEHOME)/data

# for FFTW
FFTW_DIR	= /home/ike/pub/fftw-2.1.5-gnu
FFTW_INCLUDE    = $(FFTW_DIR)/include
FFTW_LIBDIR     = $(FFTW_DIR)/lib
FFTW_LIB        = $(FFTW_LIBDIR)/librfftw.a $(FFTW_LIBDIR)/libfftw.a

# for LAPACK
LAPACK_FLAG	= -DUSE_LAPACK
LAPACK_LIBFLAG	= 
LAPACK_LD	= ftn

